Gecode::Int::Linear::Nq< Val, P, N > Class Template Reference
Other available functionality » Integer propagators

Propagator for bounds consistent n-ary linear disequality More...

`#include <linear.hh>`

## Public Member Functions

| Nq (Home home, ViewArray< P > &x, ViewArray< N > &y, Val c)
| Constructor for creation.
virtual Actor * | copy (Space &home)
| Create copy during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::Int::Linear::Lin< Val, P, N, PC_INT_VAL >
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< P > &x, ViewArray< N > &y, Val c)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| Nq (Space &home, Nq &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Int::Linear::Lin< Val, P, N, PC_INT_VAL >
| Lin (Space &home, Lin< Val, P, N, pc > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Additional Inherited Members

Protected Attributes inherited from Gecode::Int::Linear::Lin< Val, P, N, PC_INT_VAL >
ViewArray< P > | x
| Array of positive views.
ViewArray< N > | y
| Array of negative views.
Val | c
| Constant value.
Related Symbols inherited from Gecode::Int::Linear::Lin< Val, P, N, PC_INT_VAL >
void | bounds_p (ModEventDelta med, ViewArray< View > &x, Val &c, Val &sl, Val &su)
| Compute bounds information for positive views.
void | bounds_n (ModEventDelta med, ViewArray< View > &y, Val &c, Val &sl, Val &su)
| Compute bounds information for negative views.

## Detailed Description

template<class Val, class P, class N>
class Gecode::Int::Linear::Nq< Val, P, N >

Propagator for bounds consistent n-ary linear disequality

The type Val can be either `long` long int or `int`, defining the numerical precision during propagation. The types P and N give the types of the views.

The propagation condition pc refers to both views.

Requires

#include <gecode/int/linear.hh>
linear.hh

Definition at line 683 of file linear.hh.

## Constructor & Destructor Documentation

## Nq() [1/2]

template<class Val, class P, class N>

Gecode::Int::Linear::Nq< Val, P, N >::Nq | ( | Space & | home,
|  | Nq< Val, P, N > & | p )

protected

Constructor for cloning p.

## Nq() [2/2]

template<class Val, class P, class N>

Gecode::Int::Linear::Nq< Val, P, N >::Nq | ( | Home | home,
|  | ViewArray< P > & | x,
|  | ViewArray< N > & | y,
|  | Val | c )

inline

Constructor for creation.

Definition at line 477 of file int-nary.hpp.

## Member Function Documentation

## copy()

template<class Val, class P, class N>

Actor * Gecode::Int::Linear::Nq< Val, P, N >::copy | ( | Space & | home | ) |

virtual

Create copy during cloning.

Implements Gecode::Actor.

Definition at line 583 of file int-nary.hpp.

## propagate()

template<class Val, class P, class N>

ExecStatus Gecode::Int::Linear::Nq< Val, P, N >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 596 of file int-nary.hpp.

## post()

template<class Val, class P, class N>

ExecStatus Gecode::Int::Linear::Nq< Val, P, N >::post | ( | Home | home,
|  | ViewArray< P > & | x,
|  | ViewArray< N > & | y,
|  | Val | c )

static

Post propagator for .

Definition at line 482 of file int-nary.hpp.

The documentation for this class was generated from the following files:

- gecode/int/linear.hh
- gecode/int/linear/int-nary.hpp